import java.awt.*;
import java.awt.event.*;

class AwtG extends Frame 
{
    public static void main(String[] arg)
	{
        new AwtG();
    }

	//TextField t = new TextField(40);    //(case 1) t can be not final, if created here
    
	AwtG()
	{
        addWindowListener(				
			//anonymous inner class		//WindowAdapter() {  '='
			new WindowAdapter() {		//public class XXX extends WindowAdapter{
                public void windowClosing(WindowEvent e) 
				{
                    System.exit(0);
                }
            }
        );
        
		setVisible(true);
        final TextField t = new TextField(40);	//(case 2) t must be final, if created here
        add("North", t);
        Button b = new Button("Clear");
        add("South", b);
        
		b.addActionListener(
			//anonymous inner class		//ActionListener() {  '='
			new ActionListener() {		//public class XXX implements ActionListener{
                public void actionPerformed(ActionEvent e) {
                    t.setText("");	
                }
            }
        );
        pack();
    }
}

// anonymous class -- a noname subclass of WindowAdapter

// anonymous class can be derived from an interface
// in this case, its superclass is java.lang.Object
// and it should define every method in the interface

// the only object of an anonymous class is created 
// at the same time the anonymous class is defined 
// by "new WindowAdapter()" using its default constructor

// for (case 2), t must be final

// An inner class defined in a method is allowed to access
// all the instance variables and methods of the outer class
// that define it (case 1), and any final local variable in
// the method (case 2).